c      initial coordinates
       subroutine initcoordfp
c      initial coordinates for tune footprints

       INCLUDE 'param.f' 
       INCLUDE 'paramfnal.f' 
 
       real*8 rn(npartmax*4) 

       iseed = 12454643

       nmax = npart*4

       call ranuni (iseed,rn,nmax)

       amax = 6. 

c      1st particle with tiny amplitudes to determine base tune
c       x(1) = 0.01*sqrt(emit*betaxfnal)
c       px(1) = 0.0
c       y(1) = 0.01*sqrt(emit*betayfnal)
c       py(1) = 0.0
c       indexfp1(1) = 0
c       indexfp2(1) = 0

       nparts=int(sqrt(real(npart)))
       dstep = amax/real(nparts-1)*sqrt(emit*betaxfnal)
       anglestep = pi/2./real(nparts-1)

c      other particles
       do j = 0, nparts-1          
       do j2 = 0, nparts-1
       i = j2 + (nparts+1) * (j) + 1  
c       angle = 2.*pi*rn(j) 
       angle1a = real(j2)*anglestep+0.00001
c       amp1a = 15.*rn(2*npart+j) 
c       amp2a = 15.*rn(3*npart+j) 
       amp1a = dstep*real(j)+0.01*sqrt(emit*betaxfnal)
c       amp2a = dstep*real(j)
       if(j2.eq.0.and.j.eq.0) then
       angle1a = Pi/4.
       endif 
       x(i) = amp1a*cos(angle1a)
       px(i) = 0.
       y(i) = amp1a*sin(angle1a)
       py(i) = 0.
       indexfp1(i) = j2
       indexfp2(i) = j
       write(*,*) ' footprint init', i,' ',j,' ',j2, x(i),y(i)
       end do 
       end do 

       return
       end





