c      initial coordinates
       subroutine initcoorduni 
c      uniform coordinates to trace phase
c      space contours...

       INCLUDE 'param.f' 
       INCLUDE 'paramfnal.f' 
 
       real*8 rn(npartmax*4) 

       iseed = 12454643

       nmax = npart*4

       call ranuni (iseed,rn,nmax)

       amax = 10 

c      1st particle with tiny amplitudes to determine base tune
       x(1) = 0.01*sqrt(emit*betaxfnal)
       px(1) = 0.0
       y(1) = 0.01*sqrt(emit*betayfnal)
       py(1) = 0.0

       nparts=int(sqrt(real(npart-1)))
       dstep = amax/real(nparts)

       write(*,*) ' nparts = ',nparts

c      other particles
       do j = 1, nparts          
       do j2 = 1, nparts
       i = j2 + nparts * (j-1) + 1 
c       angle = 2.*pi*rn(j) 
c       angle2 = 2.*pi*rn(npart+j) 
c       amp1a = 15.*rn(2*npart+j) 
c       amp2a = 15.*rn(3*npart+j) 
       amp1a = dstep*real(j2)
       amp2a = dstep*real(j)
       x(i) = amp1a*sqrt(emit*betaxfnal)
       px(i) = 0.
       y(i) = amp2a*sqrt(emit*betayfnal)
       py(i) = 0.
       end do 
       end do 

       return
       end





