c      initial coordinates
       subroutine initcoordunir 
c      uniform coordinates to trace phase
c      space contours...

       INCLUDE 'param.f' 
       INCLUDE 'paramfnal.f' 
 
       real*8 rn(npartmax*4) 

       iseed = 12454643

       nmax = npart*4

       call ranuni (iseed,rn,nmax)

       amax = 10 

c      1st particle with tiny amplitudes to determine base tune
c       x(1) = 0.01*sqrt(emit*betastar)
c       px(1) = 0.0
c       y(1) = 0.01*sqrt(emit*betastar)
c       py(1) = 0.0

       write(*,*) ' nparts = ',nparts

c      other particles
       do i = 1, npart          
c       do j2 = 1, nparts
c       i = j2 + nparts * (j-1) + 1 
       angle = 2.*pi*rn(i) 
       angle2 = 2.*pi*rn(npart+i) 
       amp1a = 3.*rn(2*npart+i)
       amp2a = 3.*rn(3*npart+i)

c       amp1a = dstep*real(j2)
c       amp2a = dstep*real(j)
       x(i) = amp1a*sqrt(emit*betaxfnal)      
c       *cos(angle)
       px(i)=0.
c       px(i) = amp1a*sqrt(emit/betawx)*sin(angle)
       y(i) = amp2a*sqrt(emit*betayfnal)
c        *cos(angle2)
c       py(i) = amp2a*sqrt(emit/betawy)*sin(angle2)
       py(i)=0.

       end do 

       return
       end





