c     nonlinear triplet kick
c     for vertical crossing point 
      subroutine kicktripy(pxt,pyt,dx,dy,jinout)

c     input : pxt, pyt, jinout
c     output : dx, dy
c 
c     jinout - flag: -1 incoming, +1 outgoing, 0 - no kick 

      INCLUDE 'param.f'

      complex*16 tempkick, arg1, arg2, arg10, arg20 
      complex*16 comp1, comp2, tempkick2, arg3, arg30  
      complex*16 tempkico 

      xkick = 0.
      ykick = 0.
      tempkick = (0.,0.)
      tempkick2 = (0.,0.)

      pyy = pyt + thetac/2.
      py0 = thetac/2.

c     TEST ONLY:
c      pyy = pyt 
c      py0 = 0.


      if (jinout.eq.(-1)) then
      in = 3
      else if (jinout.eq.1) then
      in = 4
      endif

      dx = 0.
      dy = 0.


      arg10 = (1.,0.)
      arg20 = (1.,0.)
      arg30 = (1.,0.)

      tempkick = (0.,0.)
      tempkico = (0.,0.)
      tempkick2 = (0.,0.)

      do i = 2, maxpole

      if (jinout.eq.(-1)) then
      arg1 = -arg10 * (pxt+(0.,1.)*pyy)/r0
      arg2 = -arg20 * ((0.,1.)*py0)/r0
      if (i.eq.2) then
      arg3 = -arg30 * (pxt+(0.,1.)*pyt)/r0
      else 
      arg3 = -arg30 * ((0.,1.)*py0)/r0
      endif 
      arg10 = arg1 
      arg20 = arg2 
      arg30 = arg3 

      comp1 = (-(pxt+(0.,1.)*pyy)/r0)**(i-1)
      comp2 = (-((0.,1.)*py0)/r0*(1.,0.))**(i-1) 

      tempkico = tempkico 
     &     + (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     arg1
     &     - (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     arg2
     &     - (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     (i-1)*arg3
      tempkick = -tempkico 

c      write(*,*) ' temp 1 ',tempkick, arg1,arg2
c      tempkick2 = tempkick2 
c     &     + (an(i,in)+(0.,1.)*bn(i,in))*
c     &     ((pxt+(0.,1.)*pyy)/r0)**(i-1)*
c     &     betastar**(i/2.)*betag**(i/2.)*(-1)**(i-1)
c     &     - (an(i,in)+(0.,1.)*bn(i,in))*
c     &     ((0.,1.)*py0/r0)**(i-1)*
c     &     betastar**(i/2.)*betag**(i/2.)*(-1)**(i-1)
c     &     - (an(i,in)+(0.,1.)*bn(i,in))*
c     &     (i-1)*(((0.,1.)*py0)/r0)**(i-2)*(pxt+(0.,1.)*pyt)/r0*
c     &     betastar**(i/2.)*betag**(i/2.)*(-1)**(i-1)

      else if (jinout.eq.1) then
      arg1 = arg10 * (pxt+(0.,1.)*pyy)/r0
      arg2 = arg20 * ((0.,1.)*py0)/r0
      if (i.eq.2) then
      arg3 = arg30 * (pxt+(0.,1.)*pyt)/r0
      else 
      arg3 = arg30 * ((0.,1.)*py0)/r0
      endif 
      arg10 = arg1 
      arg20 = arg2 
      arg30 = arg3 
      comp1 = ((pxt+(0.,1.)*pyt)/r0)**(i-1)
      comp2 = (((0.,1.)*py0)/r0*(1.,0.))**(i-1) 

      tempkick = tempkick
     &     + (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     arg1
     &     - (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     arg2
     &     - (ann(i,in)+(0.,1.)*bnn(i,in))*
     &     (i-1)*arg3


c      tempkick2 = tempkick2 
c     &     + (an(i,in)+(0.,1.)*bn(i,in))*
c     &     ((pxt+(0.,1.)*pyy)/r0)**(i-1)*
c     &     betastar**(i/2.)*betag**(i/2.)
c     &     - (an(i,in)+(0.,1.)*bn(i,in))*
c     &     ((0.,1.)*py0/r0)**(i-1)*
c     &     betastar**(i/2.)*betag**(i/2.)
c     &     - (an(i,in)+(0.,1.)*bn(i,in))*
c     &     (i-1)*((0.,1.)*py0/r0)**(i-2)*(pxt+(0.,1.)*pyt)/r0*
c     &     betastar**(i/2.)*betag**(i/2.)

      else if (jinout.eq.0) then
      tempkick = (0.,0.) 
      endif      

c      write(*,*) ' temp 2 ',jinout, tempkick, tempkick2
c      write(*,*) ' temp 2 ', i, tempkick, jinout
c      write(*,*)  arg1,arg2
c      write(*,*) comp1,comp2 
c      write(*,*)  ' ' 

      end do      

      dx = dx-ckick*(tempkick)
      dy = dy+ckick*(tempkick)

      return
      end 


