c     calculates variance of trajectories
      subroutine varwire(amxrms,amyrms) 

c     uses the coordinates x, px, y, py 
c     of all particles and calculates the
c     variance of the action;
c     in tracking should use running average...

      INCLUDE 'param.f'
      INCLUDE 'paramfnal.f'

      real*8 amx(npartmax), amy(npartmax)

      bstx = betawx
      bsty = betawy

c     calculate the action for all particles
      do i = 1, npart
      pxh = (px(i)+alfaxfnal*x(j)/betaxfnal)
      pyh = (py(i)+alfayfnal*y(i)/betayfnal)
      amx(i) = x(i)*x(i)/betaxfnal+pxh*pxh*betaxfnal
      amy(i) = y(i)*y(i)/betayfnal+pyh*pyh*betayfnal
      end do 

      axt = 0.
      ayt = 0.
      axt2 = 0.
      ayt2 = 0.

      do i = 1, npart
      axt = axt + amx(i)
      ayt = ayt + amy(i)
      axt2 = axt2 + amx(i)*amx(i)
      ayt2 = ayt2 + amy(i)*amy(i)
      end do
     
      amxmean = axt / real(npart)
      amymean = ayt / real(npart)
      amx2mean = axt2 / real(npart)
      amy2mean = ayt2 / real(npart)
       
      amxrms = sqrt(dabs(amx2mean-amxmean*amxmean))/emit
      amyrms = sqrt(dabs(amy2mean-amymean*amymean))/emit

c      amxrms = amxmean/emit
c      amyrms = amymean/emit
      
      return
      end 
