c      reads input file
c 
       subroutine readinfnal 

       INCLUDE 'param.f'
       INCLUDE 'paramfnal.f'

       character*10 a10
       real*8 a(6), prev(0:nfnal,6,6), prod(6,6)
       real*8 qx,qy,qs,pi

       open(450,file="Matrices.dat")
       open(23,file="imageoflrbb.dat")

       indcav=25 

       ik = 0
       do j = 1,6
       do k = 1,6
       prev(ik,j,k)=0.
       end do
       prev(ik,j,j)=1.
       enddo

       do ik = 1, nfnal 
c       do ik = 1, 3 

       read(450,*) a10
       do j = 1, 6  
       read(450,*) (a(i),i=1,6)
       do k = 1, 6 
       arot(ik,j,k)=a(k)
       if (mod(k,2).eq.1) then
       arot(ik,j,k)=arot(ik,j,k)*1000.
c       arot(ik,j,k)=arot(ik,j,k)
       endif 
       if (mod(j,2).eq.1) then
       arot(ik,j,k)=arot(ik,j,k)/1000.
c       arot(ik,j,k)=arot(ik,j,k)
       endif 
       write(*,*) ik,j,k,' ' ,arot(ik,j,k)
       end do 
       end do 

       do j = 1,6
       do k = 1,6
       prod(j,k)=0.
       do l = 1,6
       prod(j,k)=prod(j,k)+arot(ik,j,l)*prev(ik-1,l,k)    
       end do
       end do
       end do

       do j = 1,6
       do k = 1,6
       prev(ik,j,k)=prod(j,k) 
       end do
       end do      

       end do 

       write(*,*)  ' '
       write(*,*)  ' matrix ' 
       do j = 1,6
       write(*,910) (prod(j,k),k=1,6)
       end do
 910   format(6(1x,e12.5))

       pi = 4.*datan(1.d0)
       qx=1.-dacos((prod(1,1)+prod(2,2))/2.)/2./pi
       qy=1.-dacos((prod(3,3)+prod(4,4))/2.)/2./pi
       qs=1.-dacos((prod(5,5)+prod(6,6))/2.)/2./pi

       write(*,*)  ' '
       write(*,*)  ' tunes ' 
       write(*,*) qx,' ',qy,' ',qs
       write(*,*)  ' '
 
       betaxfnal=prod(1,2)/sin(2.*pi*qx)
       betayfnal=prod(3,4)/sin(2.*pi*qy)
       alfaxfnal=(prod(1,1)-cos(2.*pi*qx))/sin(2.*pi*qx)
       alfayfnal=(prod(3,3)-cos(2.*pi*qy))/sin(2.*pi*qy)

       write(*,*)  ' '
       write(*,*)  ' betas ' 
       write(*,*) betaxfnal,' ',betayfnal
       write(*,*)  ' alfas ' 
       write(*,*) alfaxfnal,' ',alfayfnal
       write(*,*)  ' '
      
       open(460,file="Sigmas.dat")

       indcav=25 

       il = 0 
       do ik = 1, nfnal
       if (ik.ne.indcav) then 
       read(460,*) ind,asx,asy,ax,ay
       else
       asx=0.
       asy=0.
       ax=0.
       ay=0.
       endif
c      offsets in file are with respect to protons 
       xofffnal(ik)=-ax/1000.
       yofffnal(ik)=-ay/1000.
       sxfnal(ik)=asx/1000.
       syfnal(ik)=asy/1000.

       write(*,*) ' in readinfnal ', xofffnal(ik),ax

       gammaxfnal=(1+alfaxfnal**2)/betaxfnal
       gammayfnal=(1+alfayfnal**2)/betayfnal


       if (ik.eq.1) then
       xinit = xofffnal(ik)
       xinitp = -alfaxfnal/betaxfnal*xofffnal(ik)
       yinit = yofffnal(ik)
       yinitp = -alfayfnal/betayfnal*yofffnal(ik)
       else if (ik.gt.1) then
       betaxwi=(prev(ik-1,1,1)**2*betaxfnal-2*alfaxfnal*
     &          prev(ik-1,1,2)*prev(ik-1,1,1)+
     &          prev(ik-1,1,2)**2*gammaxfnal)
       betaywi=(prev(ik-1,3,3)**2*betayfnal-2*alfayfnal*
     &          prev(ik-1,3,4)*prev(ik-1,3,3)+
     &          prev(ik-1,3,4)**2*gammayfnal) 
       alfaxwi= -(prev(ik-1,1,1)*prev(ik-1,2,1)*betaxfnal
     &         -alfaxfnal*(prev(ik-1,1,2)*prev(ik-1,2,1)+
     &          prev(ik-1,1,1)*prev(ik-1,2,2))+
     &          prev(ik-1,1,2)*prev(ik-1,2,2)*gammaxfnal) 
       alfaywi= -(prev(ik-1,3,3)*prev(ik-1,4,3)*betayfnal
     &         -alfayfnal*(prev(ik-1,3,4)*prev(ik-1,4,3)+
     &          prev(ik-1,3,3)*prev(ik-1,4,4))+
     &          prev(ik-1,3,4)*prev(ik-1,4,4)*gammayfnal) 
       xinit = prev(ik-1,2,2)*xofffnal(ik)
     &        +prev(ik-1,1,2)*alfaxwi/betaxwi*xofffnal(ik)
       xinitp = -prev(ik-1,2,1)*xofffnal(ik)
     &        -prev(ik-1,1,1)*alfaxwi/betaxwi*xofffnal(ik)
       yinit = prev(ik-1,4,4)*yofffnal(ik)
     &        +prev(ik-1,3,4)*alfaywi/betaywi*yofffnal(ik)
       yinitp = -prev(ik-1,4,3)*yofffnal(ik)
     &        -prev(ik-1,3,3)*alfaywi/betaywi*yofffnal(ik)
       sxp =  prev(ik-1,2,2)*sxfnal(ik)/sqrt(emit)
       syp =  prev(ik-1,4,4)*syfnal(ik)/sqrt(emit)
       endif

       xx = xinit/sqrt(betaxfnal)/sqrt(emit)
       yy = yinit/sqrt(betayfnal)/sqrt(emit)
       xp = sqrt(betaxfnal)*(xinitp+alfaxfnal*xinit/betaxfnal)
     &      /sqrt(emit)
       yp = sqrt(betayfnal)*(yinitp+alfayfnal*yinit/betayfnal)
     &      /sqrt(emit)
       ampx=sqrt(xx**2+xp**2)
       ampy=sqrt(yy**2+yp**2)
       amptot=sqrt(ampx**2+ampy**2)

       write(*,*) ' in readinfnal 2 ', xinit, xx, emit 

       if (ik.lt.indcav) then 
       write(23,911) ik,xx,xp,yy,yp,sxp,syp,ampx,ampy,amptot
       else if (ik.gt.indcav) then 
       write(23,911) ik-1,xx,xp,yy,yp,sxp,syp,ampx,ampy,amptot
       endif
 911   format(i5,9(1x,f10.4))

c       do ik = 1, nfnal 
c       write(*,*) ik,xofffnal(ik),yofffnal(ik),
c     &            sxfnal(ik),syfnal(ik)

c       write(*,*) ik,xofffnal(ik),yofffnal(ik),
c     &            sxfnal(ik),syfnal(ik)
       end do
       
 900   format(a80)

   
       open (470,file="excluded.dat")
       do i = 1, nfnal 
       read (470,*,end=990) i1 
       iexclu(i) = i1    
       end do

 990   continue
       iextot = i-1 
       write (*,*) ' number of excluded collisions = ',iextot
      
       close(460)
       close(470)

       return
       end 


