c      rotation transformation
c      performs a phase space rotation
c      between IPs 
c    
       subroutine rotwire(phx,phy)

       INCLUDE 'param.f'

       real*8 rm(4,4) 

       do i = 1, 4
       do j = 1, 4
          rm(i,j) = 0.
       end do
       end do
 
       do i = 1, 4
          rm(i,i) = 1.
       end do 

       rm(1,1) = dcos(phx) 
       rm(1,2) = betawx*dsin(phx)
       rm(2,1) = -dsin(phx)/betawx
       rm(2,2) = dcos(phx)

       rm(3,3) = dcos(phy) 
       rm(3,4) = betawy*dsin(phy)
       rm(4,3) = -dsin(phy)/betawy
       rm(4,4) = dcos(phy)

       do i = 1, npart

       xo = x(i)
       yo = y(i)
       pxo = px(i)
       pyo = py(i)

       x(i) = rm(1,1)*xo+rm(1,2)*pxo
       px(i) = rm(2,1)*xo+rm(2,2)*pxo
       y(i) = rm(3,3)*yo+rm(3,4)*pyo
       py(i) = rm(4,3)*yo+rm(4,4)*pyo

       end do

       end
